const express = require('express');
const sql = require('./database');

const app = express();

// app.get('/transaction', async (req, res) => {
//   try {
//     const result = await sql.query`SELECT * FROM dbo.iclock_transaction`;
//     res.json(result.recordset);
//   } catch (error) {
//     console.log('Error querying MSSQL:', error);
//     res.sendStatus(500);
//   }
// });

// app.get('/transaction/:id/:id2', async (req, res) => {
//     const empCode = req.params.id; // Route parameter for emp_code
//     const specificDate = req.params.id2; // Route parameter for specific date
  
//     console.log(empCode, specificDate)
  
//     if (!empCode || !specificDate) {
//       res.status(400).json({ error: 'empCode and date query parameters are required' });
//       return;
//     }
  
//     try {
//       const result = await sql.query`SELECT * FROM dbo.iclock_transaction WHERE empCode = ${empCode} AND puch_time >= ${specificDate} AND puch_time < DATEADD(day, 1, ${specificDate})`;
//       res.json(result.recordset);
//     } catch (error) {
//       console.log('Error querying MSSQL:', error);
//       res.sendStatus(500);
//     }
//   });

  app.get('/transaction', async (req, res) => {
    const empCode = req.query.emp_code;
    const startDate = req.query.start_date;
    const endDate = req.query.end_date;
  
    try {
        const result = await sql.query`
        SELECT 
          pe.id AS id, 
          pe.emp_code AS 'Employee ID',
          pe.first_name AS 'First Name',
          FORMAT(apb.att_date, 'yyyy-MM-dd') AS 'Date',
          FORMAT(apb.check_in, 'hh:mm tt') AS 'Check In',
          FORMAT(apb.check_out, 'hh:mm tt') AS 'Check Out',
          apb.duty_worked AS 'Duration (Minutes)',
          apb.clock_in AS 'Clock In',
          apb.clock_out AS 'Clock Out',
          apb.total_time AS 'Total Time (Minutes)',
          CASE
              WHEN apb.total_time > apb.duration THEN 
                  apb.total_time - apb.duration
              ELSE 0
          END AS 'Overtime (Minutes)',
          CASE
              WHEN apb.total_time < apb.duration THEN 
                  apb.duration - apb.total_time
              ELSE 0
          END AS 'Undertime (Minutes)'
      FROM 
          dbo.personnel_employee pe
      LEFT JOIN
          dbo.att_payloadbase apb ON pe.id = apb.emp_id
      WHERE 
          pe.emp_code = ${empCode}
          AND apb.att_date >= ${startDate}
          AND apb.att_date <= ${endDate}
      ORDER BY
          apb.att_date;
    
        `;
    
      res.json(result.recordset);

    } catch (error) {
      console.log('Error querying MSSQL:', error);
      res.sendStatus(500);
    }
  });


app.listen(4000, () => {
  console.log('Server listening on port 4000');
});